#include <windows.h>
#include <commctrl.h>
#include <stdio.h>
#include "resource.h"
#include "cmdln.h"
#include "atoH.h"

//#define APPNAME "DshowShow" //       
//#define APPRESNAME DshowShow //   APPNAME!!!!!!!!!!!!!!!!!!!!!!!

struct FASTSET
{
	char *app;
	UINT applen;
	RECT apprt;
	DWORD style;
	HWND fndwnd;
};

BOOL CALLBACK EnumWindAndFindProcess(HWND hwnd, FASTSET *pfs)
{
	char path[MAX_PATH];
	UINT len;//, err;
	//DWORD IDthread, IDprocess;
	//HANDLE hProcess;
	do{
		if(GetParent(hwnd))
			break;
		if(!IsWindowVisible(hwnd))
			break;
		len = GetWindowText(hwnd, path, MAX_PATH);
		if(!len || !path[0])
			break;;
		/*len = GetWindowModuleFileName(hwnd, path, MAX_PATH);
		err = GetLastError(); //   !!!!    HWND  exe    
		IDthread = GetWindowThreadProcessId(hwnd, &IDprocess); //   ,    
		hProcess = OpenThread(PROCESS_QUERY_INFORMATION, 0, IDthread); //      
		err = GetModuleFileName((HMODULE)hProcess, (LPCH)&path, MAX_PATH); //,     
		err = GetLastError();
		CloseHandle(hProcess);*/
		if(len < pfs->applen)
			break;
		//len -= pfs->applen;
		//if(len != pfs->applen && path[len] != '\\')
		//	break;
		if(!strcmp(path, pfs->app))
		{
			pfs->fndwnd = hwnd;
			return 0;
		}
	}while(0);
	return 1;
}

LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
void copyToClipboard(HWND hwnd);	//        
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, PSTR szCmdLine, int iCmdShow)
{	//      
	{//: __ X Y   x : game.exe 0 10 800 600 x14CFC000 2
		int  argn;
		char **argv = CommandLineToArgv(szCmdLine, &argn);
		if(argn > 5)
		{	//  
			FASTSET fs = {0};
			DWORD twait = 0;
			fs.app = argv[0];
			fs.apprt.left = atoi(argv[1]);
			fs.apprt.top = atoi(argv[2]);
			fs.apprt.right = atoi(argv[3]);
			fs.apprt.bottom = atoi(argv[4]);
			if(argv[5][0] == 'x' ||argv[5][0] == 'X')
				fs.style = atoH(&argv[5][1]);
			else
				twait = atoi(argv[5]);
			if(argn > 6)
				twait = atoi(argv[6]);
			Sleep(twait * 1000); // X 
			fs.applen = strlen(fs.app);
			EnumWindows((WNDENUMPROC)EnumWindAndFindProcess, (LPARAM)&fs);//       
			if(!fs.fndwnd)
				exit(0); //    ,  
			SetWindowLong(fs.fndwnd, GWL_STYLE, fs.style);
			SetWindowPos(fs.fndwnd, 0, fs.apprt.left, fs.apprt.top,
					fs.apprt.right, fs.apprt.bottom, SWP_DRAWFRAME | SWP_FRAMECHANGED | SWP_NOOWNERZORDER | SWP_NOZORDER);
			exit(0); //    
		}
		GlobalFree(argv);
	}
	static char szAppName[] = "DistWndCtl"; //  +  .
	//           resource.rc -
	//.      CLASS. !        !
	HWND hwnd;
	MSG msg;
	WNDCLASSEX wndclass;
	wndclass.cbSize = sizeof(wndclass);
	wndclass.style = CS_HREDRAW | CS_VREDRAW;
	wndclass.lpfnWndProc = WndProc;
	wndclass.cbClsExtra = 0;
	wndclass.cbWndExtra = DLGWINDOWEXTRA;
	wndclass.hInstance = hInstance;
	wndclass.hIcon = LoadIcon(NULL, IDI_APPLICATION);
	wndclass.hCursor = LoadCursor(NULL, IDC_ARROW);
	wndclass.hbrBackground =(HBRUSH) COLOR_BTNSHADOW;
	wndclass.lpszMenuName = NULL;
	wndclass.lpszClassName = szAppName;
	wndclass.hIconSm = LoadIcon(NULL, IDI_APPLICATION);
	RegisterClassEx(&wndclass);
	if((hwnd = CreateDialog(hInstance, szAppName, 0, NULL))==0)
		return 1;
	SendMessage(hwnd, WM_INITDIALOG, (unsigned int)hInstance, (long) szCmdLine);
	ShowWindow(hwnd, iCmdShow);
	UpdateWindow(hwnd);
	while(GetMessage(&msg, NULL, 0, 0))
	{
		if(msg.message == WM_KEYDOWN && msg.wParam == 0x43 && msg.hwnd == GetDlgItem(hwnd, IDL_WINDOWS))
			if(HIWORD(GetKeyState(VK_CONTROL)))
				copyToClipboard(hwnd);
		if(IsDialogMessage(hwnd, &msg))
			continue;
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}

struct WNDTABLE
{
	WORD nWindows;
	WORD nSlots;
	struct WINDOW
	{
		HWND hwnd;
		size_t nInList;
	}wnd[0];
};
WNDTABLE *pWnt = 0;

BOOL CALLBACK EnumWindowsProc(HWND hwnd, WNDTABLE *pW)
{
	char bcap[3];
	if(pWnt->nWindows >= pWnt->nSlots)
	{
		WORD ns = pWnt->nSlots + 16;
		pWnt = (WNDTABLE*)realloc(pWnt, sizeof(WNDTABLE) + (sizeof(WNDTABLE::WINDOW) * ns));
		memset(&pWnt->wnd[pWnt->nSlots], 0, sizeof(WNDTABLE::WINDOW) * 16);
		pWnt->nSlots = ns;
	}
	if(GetParent(hwnd))
		return 1;
	if(!IsWindowVisible(hwnd))
		return 1;
	GetWindowText(hwnd, bcap, 3);
	if(!bcap[0])
		return 1;
	pWnt->wnd[pWnt->nWindows++].hwnd = hwnd;
	return 1;
}

void FillList(HWND hwnd)
{
	if(pWnt)
	{
		WORD ni = pWnt->nSlots;
		memset(pWnt, 0, sizeof(WNDTABLE) + (sizeof(WNDTABLE::WINDOW) * ni));
		pWnt->nSlots = ni;
	}else{
		pWnt = (WNDTABLE*) malloc(sizeof(WNDTABLE) + (sizeof(WNDTABLE::WINDOW) * 16));
		memset(pWnt, 0, sizeof(WNDTABLE) + (sizeof(WNDTABLE::WINDOW) * 16));
		pWnt->nSlots = 16;
	}
	SendDlgItemMessage(hwnd, IDL_WINDOWS, LB_RESETCONTENT, 0, 0);
	EnumWindows((WNDENUMPROC)EnumWindowsProc, (LPARAM)pWnt);
	for(WORD i = 0; i < pWnt->nWindows; i++)
	{
		WCHAR cap[127];
		GetWindowTextW(pWnt->wnd[i].hwnd, cap, 127);
		pWnt->wnd[i].nInList = SendDlgItemMessageW(hwnd, IDL_WINDOWS, LB_INSERTSTRING, i, (LPARAM)cap);
	}
}

LRESULT CALLBACK WndProc(HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
	switch(iMsg)
	{
	case WM_INITDIALOG:
		{
			FillList(hwnd);
			TOOLINFO ti = {0};
			ti.cbSize = sizeof(TOOLINFO); //        
			ti.uFlags = TTF_IDISHWND | TTF_SUBCLASS;
			ti.hwnd = hwnd;
			ti.hinst = GetModuleHandle(0);
			HWND hwtooltip = CreateWindow(TOOLTIPS_CLASS, 0, WS_POPUP|TTS_NOPREFIX|TTS_ALWAYSTIP, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, hwnd, 0, ti.hinst, 0);
			for(BYTE d = 0, i = 0; i < 12; i++)
			{
				ti.lpszText = (LPSTR)IDS_HLP0 + d; //.  
				ti.uId = (UINT)GetDlgItem(hwnd, IDE_POSX + i); //HWND    
				SendMessage(hwtooltip, TTM_ADDTOOL, 0, (LPARAM)&ti); // 
				if(i < 3 && (i == 0 || i == 2))
					continue;
				d++;
			}
			ti.lpszText = (LPSTR)IDS_HLP10;
			ti.uId = (UINT)GetDlgItem(hwnd, IDOK);
			SendMessage(hwtooltip, TTM_ADDTOOL, 0, (LPARAM)&ti);
			//RegisterHotKey(hwnd, 0x1, MOD_CONTROL, 0x43); //!     !
		}
		return 1;
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDL_WINDOWS:
			if(HIWORD(wParam) == LBN_SELCHANGE)
			{
				char buf[32];
				WINDOWINFO wndi = {0};
				INT_PTR idx = SendDlgItemMessage(hwnd, IDL_WINDOWS, LB_GETCURSEL, 0, 0);
				wndi.cbSize = sizeof(WINDOWINFO);
				if(!GetWindowInfo(pWnt->wnd[idx].hwnd, &wndi))
					SendDlgItemMessage(hwnd, IDE_HWND, WM_SETTEXT, 0, (LPARAM)"#Error");
				else{
					sprintf(buf, "0x%.8X", pWnt->wnd[idx].hwnd);
					SendDlgItemMessage(hwnd, IDE_HWND, WM_SETTEXT, 0, (LPARAM)buf);
				}
				SetDlgItemInt(hwnd, IDE_POSX, wndi.rcWindow.left, 1);
				SetDlgItemInt(hwnd, IDE_POSY, wndi.rcWindow.top, 1);
				SetDlgItemInt(hwnd, IDE_RESX, wndi.rcWindow.right - wndi.rcWindow.left, 1);
				SetDlgItemInt(hwnd, IDE_RESY, wndi.rcWindow.bottom - wndi.rcWindow.top, 1);
				sprintf(buf, "0x%.8X", wndi.dwStyle);
				SendDlgItemMessage(hwnd, IDE_STYLE, WM_SETTEXT, 0, (LPARAM)buf);
				buf[0] = (wndi.dwStyle & WS_BORDER) ? BST_CHECKED : BST_UNCHECKED;
				CheckDlgButton(hwnd, IDC_BORDER, buf[0]);
				buf[0] = (wndi.dwStyle & WS_CAPTION) ? BST_CHECKED : BST_UNCHECKED;
				CheckDlgButton(hwnd, IDC_CAPTION, buf[0]);
				buf[0] = (wndi.dwStyle & WS_OVERLAPPED) ? BST_CHECKED : BST_UNCHECKED;
				CheckDlgButton(hwnd, IDC_OVERLAPPED, buf[0]);
				buf[0] = (wndi.dwStyle & WS_THICKFRAME) ? BST_CHECKED : BST_UNCHECKED;
				CheckDlgButton(hwnd, IDC_THICKFRAME, buf[0]);
				return 1;
			}
			break;
		case IDOK:
			while(HIWORD(wParam) == BN_CLICKED)
			{
				WINDOWINFO wndi = {0};
				INT_PTR idx = SendDlgItemMessage(hwnd, IDL_WINDOWS, LB_GETCURSEL, 0, 0);
				if(idx == -1 || idx > pWnt->nWindows)
					return 0;
				wndi.cbSize = sizeof(WINDOWINFO);
				GetWindowInfo(pWnt->wnd[idx].hwnd, &wndi);
				wndi.rcWindow.left = GetDlgItemInt(hwnd, IDE_POSX, 0, 1);
				wndi.rcWindow.top = GetDlgItemInt(hwnd, IDE_POSY, 0, 1);
				wndi.rcWindow.right = GetDlgItemInt(hwnd, IDE_RESX, 0, 1);
				wndi.rcWindow.bottom = GetDlgItemInt(hwnd, IDE_RESY, 0, 1);
				if(IsDlgButtonChecked(hwnd, IDC_BORDER) == BST_CHECKED)
					wndi.dwStyle |= WS_BORDER;
				else
					wndi.dwStyle &= ~WS_BORDER;
				if(IsDlgButtonChecked(hwnd, IDC_CAPTION) == BST_CHECKED)
					wndi.dwStyle |= WS_CAPTION;
				else
					wndi.dwStyle &= ~WS_CAPTION;
				if(IsDlgButtonChecked(hwnd, IDC_OVERLAPPED) == BST_CHECKED)
					wndi.dwStyle |= WS_OVERLAPPED;
				else
					wndi.dwStyle &= ~WS_OVERLAPPED;
				if(IsDlgButtonChecked(hwnd, IDC_THICKFRAME) == BST_CHECKED)
					wndi.dwStyle |= WS_THICKFRAME;
				else
					wndi.dwStyle &= ~WS_THICKFRAME;
				SetWindowLong(pWnt->wnd[idx].hwnd, GWL_STYLE, wndi.dwStyle);
				SetWindowPos(pWnt->wnd[idx].hwnd, 0, wndi.rcWindow.left, wndi.rcWindow.top,
					wndi.rcWindow.right, wndi.rcWindow.bottom, SWP_DRAWFRAME | SWP_FRAMECHANGED | SWP_NOOWNERZORDER | SWP_NOZORDER);
				return 1;;

			}
			break;
		case IDB_RECALC:
			if(HIWORD(wParam) == BN_CLICKED)
			{
				FillList(hwnd);
				return 1;
			}
			break;
		case IDB_FULLSCREEN:
			SetDlgItemInt(hwnd, IDE_POSX, 0, 1);
			SetDlgItemInt(hwnd, IDE_POSY, 0, 1);
			SetDlgItemInt(hwnd, IDE_RESX, GetSystemMetrics(SM_CXSCREEN), 1);
			SetDlgItemInt(hwnd, IDE_RESY, GetSystemMetrics(SM_CYSCREEN), 1);
			break;
		}
		break;
//	case WM_HOTKEY:
//		if(wParam == 1)	//        
//			copyToClipboard(hwnd); //   
//		return 0;
	case WM_CLOSE:
		UnregisterHotKey(hwnd, 0x1);
		DestroyWindow(hwnd);
		return 1;
	case WM_DESTROY:
		if(pWnt)
		{
			free(pWnt);
			pWnt = 0;
		}
		PostQuitMessage(0);
		return 0;
	}
	return DefDlgProc(hwnd, iMsg, wParam, lParam);
}

void copyToClipboard(HWND hwnd)
{	//        
	INT_PTR idx = SendDlgItemMessage(hwnd, IDL_WINDOWS, LB_GETCURSEL, 0, 0);
	INT_PTR cch = SendDlgItemMessage(hwnd, IDL_WINDOWS, LB_GETTEXTLEN, idx, 0);
	if(!OpenClipboard(hwnd)) 
		return;
	HGLOBAL hgBuf = GlobalAlloc(GMEM_MOVEABLE, cch + 1);
	char *buf = (char*) GlobalLock(hgBuf);
	SendDlgItemMessage(hwnd, IDL_WINDOWS, LB_GETTEXT, idx, (LPARAM)buf);
	GlobalUnlock(hgBuf);
	EmptyClipboard();
	SetClipboardData(CF_TEXT, hgBuf);
	CloseClipboard();
}